#ifndef DATA_SHADOW_H
#define DATA_SHADOW_H

#define DATA_SHADOW_TABLE_SIZE  1000
#define MAX_DATA_SHADOW_ENTRIES 2000
#define NO_SHADOW_ENTRY -1

typedef int SHADOW_ENTRY_INDEX;

typedef struct data_shadow_entry {
	union {
		void* addr; // right now, we just store addresses			
	} val;
	SHADOW_ENTRY_INDEX next_shadow_entry;
} data_shadow_entry;

typedef struct data_shadow_entry_manager {
	SHADOW_ENTRY_INDEX shadow_entry;		
} data_shadow_entry_manager;

extern void initialize_data_shadow_module();
extern int add_shadow_entry(int p_idx, void *p_addr);
extern int check_shadow_value(int p_idx, void *p_addr, void **p_restore_addr, int *);

#endif

